/*
LDAPEOAdaptor.framework - Providing EOF with an interface for LDAP
Copyright (C) 1998  Ryan Krebs and Stanford University

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Comments, suggestions, bug reports, etc can be directed to:
rkrebs@cisnet.stanford.edu
*/

#import <EOAccess/EOAccess.h>

// NSDictionary keys for the connection dictionary
#define serverNameKey		@"serverName"
#define serverPortKey		@"serverPort"
#define userDNKey		@"userName"
#define passwordKey		@"password"
#define defaultBaseKey		@"defaultBase"
#define schemaBaseKey		@"schemaBase"
#define valueSeparatorKey	@"valueSeparator"
#define timeoutKey		@"timeout"
#define authenticationMethodKey	@"authenticationMethod"

@interface LDAPAdaptor : EOAdaptor
{}
- (EOAdaptorContext *)createAdaptorContext;
- (BOOL)isValidQualifierType:(NSString *)typeName model:(EOModel *)model;
- (void)assertConnectionDictionaryIsValid;
- (Class)defaultExpressionClass;
@end

@interface LDAPAdaptor (ExternalTypeMapping)
+ (NSString *)internalTypeForExternalType:(NSString *)extType model:(EOModel *)model;
+ (NSArray *)externalTypesWithModel:(EOModel *)model;
+ (void)assignExternalInfoForAttribute:(EOAttribute *)attribute;
@end