/*
LDAPEOAdaptor.framework - Providing EOF with an interface for LDAP
Copyright (C) 1998  Ryan Krebs and Stanford University

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Comments, suggestions, bug reports, etc can be directed to:
rkrebs@cisnet.stanford.edu
*/

#import <EOAccess/EOAccess.h>

@interface LDAPChannel : EOAdaptorChannel
{
	NSArray		*_attributes;
	BOOL		_isOpen, _fetchInProgress;
	int		_ldapMsgID, _ldapErrorNum;
	LDAPController	*_controller;	
}
- (BOOL)isOpen;
- (BOOL)isFetchInProgress;

- (void)openChannel;
- (void)closeChannel;

- (void)setAttributesToFetch:(NSArray *)attributes;
- (NSArray *)attributesToFetch;

// Is this really needed?
- (NSString *)primaryKeyForNewRowWithEntity:(EOEntity *)entity;
@end

@interface LDAPChannel (Operations)
- (void)selectAttributes:(NSArray *)attributes fetchSpecification:(EOFetchSpecification *)fetchSpec lock:(BOOL)lock entity:(EOEntity *)entity;
- (NSMutableDictionary *)fetchRowWithZone:(NSZone *)zone;
- (void)cancelFetch;
- (void)insertRow:(NSDictionary *)row forEntity:(EOEntity *)entity;
- (unsigned)updateValues:(NSDictionary *)values inRowsDescribedByQualifier:(EOQualifier *)qualifier entity:(EOEntity *)entity;
- (unsigned)deleteRowsDescribedByQualifier:(EOQualifier *)qualifier entity:(EOEntity *)entity;
@end

@interface LDAPChannel (Descriptions)
- (NSArray *)describeResults;
- (NSArray *)describeTableNames;
- (EOModel *)describeModelWithTableNames:(NSArray *)tableNames;
@end